/**********************************************************************
  openfft_finalize is used to clean up the calculation 
***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "openfft.h"

double openfft_finalize()
{

  int numprocs,myid,ID;
  double Stime_proc,Etime_proc,time0;
  MPI_Comm mpi_comm_level1 = MPI_COMM_WORLD;

  time0 = 0.0;

  MPI_Comm_size(mpi_comm_level1,&numprocs);
  MPI_Comm_rank(mpi_comm_level1,&myid);

  if (OFFT_measure_time==1) openfft_dtime(&Stime_proc);

  free(Num_Snd_Grid_AB2CA);
  free(Num_Rcv_Grid_AB2CA);
  free(Num_Snd_Grid_CA2CB);
  free(Num_Rcv_Grid_CA2CB);

  for (ID=0; ID<numprocs; ID++){
    free(Index_Snd_Grid_AB2CA[ID]);
  }  
  free(Index_Snd_Grid_AB2CA);
  
  for (ID=0; ID<numprocs; ID++){
    free(Index_Rcv_Grid_AB2CA[ID]);
  }  
  free(Index_Rcv_Grid_AB2CA);

  free(ID_NN_AB2CA_S);
  free(ID_NN_AB2CA_R);
  free(GP_AB2CA_S);
  free(GP_AB2CA_R);

  for (ID=0; ID<numprocs; ID++){
    free(Index_Snd_Grid_CA2CB[ID]);
  }  
  free(Index_Snd_Grid_CA2CB);
    
  for (ID=0; ID<numprocs; ID++){
    free(Index_Rcv_Grid_CA2CB[ID]);
  }  
  free(Index_Rcv_Grid_CA2CB);

  free(ID_NN_CA2CB_S);
  free(ID_NN_CA2CB_R);
  free(GP_CA2CB_S);
  free(GP_CA2CB_R);

  fftw_destroy_plan(OFFT_p_A);  
  fftw_destroy_plan(OFFT_p_B);  
  fftw_destroy_plan(OFFT_p_C);  
  fftw_cleanup();

  fftw_free(OFFT_in);
  fftw_free(OFFT_out);

  if (OFFT_measure_time==1){
    openfft_dtime(&Etime_proc);
    time0 = Etime_proc -Stime_proc;
  }

  return time0;
}
